package executor;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import javax.swing.JPanel;

public class GraphicPanel extends JPanel {

	private static final long serialVersionUID = -3820538199712545128L;
	
	public ArrayList<Point> points;
	public ArrayList<Line> lines;
	
	ExecutorService es = Executors.newCachedThreadPool();
	
	public GraphicPanel() {
		points = new ArrayList<Point>();
		lines = new ArrayList<Line>();
		this.addMouseListener(new MouseAdapter() {
			
			public void mousePressed(MouseEvent e) {
				points.add(new Point(e.getX(), e.getY()));				
				if(points.size() > 1) {
					Point p1 = points.get(points.size()-1);
					Point p2 = points.get(points.size()-2);
					es.submit(new DrawLineThread(p1,p2, (GraphicPanel) e.getComponent()));
				}
				repaint();	
			}			
		});
	}
	
	@Override
	protected void paintComponent(Graphics g) {
		super.paintComponent(g);
		for(Point p : points)
			g.fillOval(p.x, p.y, 10, 10);
		for(Line l : lines)
			g.drawLine(l.p1.x+5, l.p1.y+5, l.p2.x+5, l.p2.y+5);
	}
	
	
}
