package forkjoin;

import java.util.ArrayList;
import java.util.concurrent.RecursiveAction;

public class Sum extends RecursiveAction {

	private static final long serialVersionUID = 1741339233801267235L;
	int start;
	int end;
	Long sum;
	
	ArrayList<Integer> elements;
	public Sum(ArrayList<Integer> elements) {
		this.elements = elements;
		start = 0;
		end = this.elements.size();
		sum = 0L;
	}
	
	public Sum(ArrayList<Integer> elements, int start, int end) {
		this.elements = elements;
		this.start = start;
		this.end = end;
		sum = 0L;
	}
	
	@Override
	protected void compute() {
		if(end-start <= 2) {				
			for(int i = start; i < end; i++)
				sum += elements.get(i);			
		}
		else {
			Sum firstTask = new Sum(elements, start, (start+end)/2);
	        Sum secondTask = new Sum(elements, (start+end)/2, end);
	
	        Sum.invokeAll(firstTask, secondTask);		
	        sum += firstTask.sum + secondTask.sum;
		}
	}
	
	
}
